#include <sys/types.h>
#include <libetc.h>
#include <libapi.h>
#include <libmcrd.h>
#include <sys\file.h>
#include <stdio.h>

#define	MC_FILENAME	"BESLPSP00000BIOSTOOL"	// Filename made by PocketStation Save Manager

unsigned char	*data = (unsigned char *)0x80010000;	// RAM Dump Space

long	MCport;

void	MC_Init(void)
{
	long	result;

	memset(data, 0, 16*1024);

	// Init MC and Check Port 1
	printf("MemCardInit\n");
	MCport = 0x00;
	MemCardInit(1);
	printf("MemCardStart\n");
	MemCardStart();
	printf("MemCardSync\n");
	MemCardSync(0, NULL, &result);
	printf("MemCardAccept\n");
	MemCardAccept(MCport);
	MemCardSync(0, NULL, &result);
	if ((result == McErrNewCard) || (result == McErrNone))
	{
		printf("MemCardOpen\n");
		if (MemCardOpen(MCport, MC_FILENAME, O_RDONLY) == McErrNone)
		{
			printf("MemCardRead\n");
			MemCardReadData((unsigned long *)data, 8*1024, 16*1024);
			MemCardSync(0, NULL, &result);
			printf("MemCardClose\n");
			MemCardClose();
			return;
		}
	}

	// No MC
	MCport = -1;
}

/******************************************/

int			main(void)
{
	int	i;
	ResetCallback();
	PadInit(0);

	printf("%x\n", data);	// Print RAM Dump Space Address
	MC_Init();
/*
//	Raw Directory Dump Test
	memset(data, 0, 2*1024);

	printf("InitCARD\n");
	InitCARD(1);
	printf("StartCARD\n");
	StartCARD();

	for (i = 0; i < 16; i++)
	{
		printf("Read %d, %d\n", i, _card_read(0,i,data));
		printf("Wait\n");
		while (_card_status(0) == 2);
		data += 128;
	}
	printf("Done\n");
*/
	while (1);

	return (0);
}
